package im.creep.luabucket2;

import com.sun.deploy.util.LoggerTraceListener;
import org.luaj.vm2.LoadState;
import org.luaj.vm2.LuaError;
import org.luaj.vm2.LuaFunction;
import org.luaj.vm2.LuaTable;
import org.luaj.vm2.lib.jse.CoerceJavaToLua;
import org.luaj.vm2.lib.jse.JsePlatform;
import sun.rmi.runtime.Log;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * some day I will put some licence text here, but not now. //apiocera
 */
public class LuaManager {
    private static LuaManager ourInstance = new LuaManager();
    private ArrayList<LuaFunction> sandboxes = new ArrayList<LuaFunction>();
    private LuaTable globals;

    public static LuaManager getInstance() {
        return ourInstance;
    }

    private LuaManager() {
        reset();
    }

    private void resetGlobals() {
        globals = JsePlatform.standardGlobals();
    }

    public void addGlobal(String alias, Object o) {
        globals.set(alias, CoerceJavaToLua.coerce(o));
    }


    public void runSnip(File snip) {
        LuaFunction function;
        FileInputStream fin;

        try {
            fin = new FileInputStream(snip);
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            return;
        }

        try {
            function = LoadState.load(fin, snip.toString(), globals);
            sandboxes.add(function);
            function.call();
        } catch (IOException e) {
            Logger.getLogger("minecraft").log(Level.SEVERE, "[LuaBucket]: Snippet was deleted between directory scan and read. This isn't supposed to happen.");
        } catch (LuaError le) {
            Logger.getLogger("minecraft").log(Level.SEVERE, "[LuaBucket]: " + le.getMessage());
        } finally {
            try {
                fin.close();
            } catch (IOException e) {
                Logger.getLogger("minecraft").log(Level.SEVERE, "[LuaBucket]: Could not close snippet. This is not okay.");
            }
        }
    }

    public void reset() {
        resetGlobals();
        sandboxes.clear();
    }
}
